//+------------------------------------------------------------------+
//|                                                OnlyPivot_mod.mq4 |
//|                                                     David Willis |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "David Willis"
#property link      ""


extern double  Lots = 0.1;
extern int     endtradingtime=17;
extern int     slippage = 5;
extern int     MagicNumber = 123456;

//profit targets
extern double      TP1 = 50;       //first profit target
extern double      TP2 = 110;      //second profit target
extern double      TP3 = 0;        //third profit target
//trail stop loss
extern double      SLinitial=75;   //initial stop loss
extern double      SL1 = -1;
extern double      SL2 = -50;
extern double      SL3 = 0;
extern double      SLA1 = 50;     //pips provit to move to first sl
extern double      SLA2 = 100;
extern double      SLA3 = 0; 
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
  int cnt;
  double daily = Open[Hour()];
  int numbertrades=trades();
  double sl,tp1,tp2,tp3;
   
  Comment("opentrades = ",opentrades());

   
   
// Take care of open trades
   if(opentrades()>0)
   {   
     
      //modify stop loss
      
      modifystoploss(); 
      
      //close at end of day
      if(endofday()>0) {closealltrades();}      
      
      //stop and reverse 0=short, 1=long
      if(tradedirection()==1 && iMA(Symbol(),0,2,0,1,0,1) < daily && Minute()==0 && iMA(Symbol(),0,2,0,1,0,2) > daily)  
      {
            closealltrades();
            if(opentrades()>0){return(0);}
            if (Hour()<= endtradingtime)
            {             
               sl=Bid+SLinitial*Point;
               tp1=Bid-TP1*Point;
               tp2=Bid-TP2*Point;
               tp3=Bid-TP3*Point;
               OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);
               if(numbertrades>1)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
               if(numbertrades>2)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
             }
       }       
        
        
        //Short trade        
        if(tradedirection()==0 && iMA(Symbol(),0,2,0,1,0,1) > daily && Minute()==0 && iMA(Symbol(),0,2,0,1,0,2)< daily)
        {
          closealltrades();
          if(opentrades()>0){return(0);}
          if (Hour()<= endtradingtime)
          {
               sl=Ask-SLinitial*Point;
               tp1=Ask+TP1*Point;
               tp2=Ask+TP2*Point;
               tp3=Ask+TP3*Point;
               OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);
               if(numbertrades>1)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
               if(numbertrades>2)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
          }
        }
        
   }
   // No open trades   
   if(opentrades()==0 && Hour()>=1) 
   {
      //Start of day
      if(Hour()==1 && Minute()==0)
      {
         if(iMA(Symbol(),0,2,0,1,0,1) > daily)
         {
               sl=Ask-SLinitial*Point;
               tp1=Ask+TP1*Point;
               tp2=Ask+TP2*Point;
               tp3=Ask+TP3*Point;
               OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);
               if(numbertrades>1)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
               if(numbertrades>2)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
         }
         if(iMA(Symbol(),0,2,0,1,0,1) < daily) 
         {            
               sl=Bid+SLinitial*Point;
               tp1=Bid-TP1*Point;
               tp2=Bid-TP2*Point;
               tp3=Bid-TP3*Point;
               OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);
               if(numbertrades>1)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
               if(numbertrades>2)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
         }
      }
        
      // 2wma cross 
      if (Hour()<= endtradingtime && opentrades()==0 && Minute()==0)
      {
         if (iMA(Symbol(),0,2,0,1,0,1) > daily && iMA(Symbol(),0,2,0,1,0,2) < daily)
         {
            
               sl=Ask-SLinitial*Point;
               tp1=Ask+TP1*Point;
               tp2=Ask+TP2*Point;
               tp3=Ask+TP3*Point;
               OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);
               if(numbertrades>1)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
               if(numbertrades>2)
               {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
               
         }
         if (iMA(Symbol(),0,2,0,1,0,1) < daily && iMA(Symbol(),0,2,0,1,0,2) > daily)
         {
               sl=Bid+SLinitial*Point;
               tp1=Bid-TP1*Point;
               tp2=Bid-TP2*Point;
               tp3=Bid-TP3*Point;
               OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);
               if(numbertrades>1)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
               if(numbertrades>2)
               {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
           
         }
         
      }  
       
   }  
         
   return(0);
} 
//+------------------------------------------------------------------+



void modifystoploss()
{
  int cnt;
  double buyprice, currentsl,newsl=0;
  
  
  //find current buyprice and stop loss
  for(cnt=0;cnt<OrdersTotal();cnt++)   
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
      {
        buyprice=OrderOpenPrice();
        currentsl=OrderStopLoss();
      }
    }  
  
  
  //for long trades
  if(tradedirection()==1)
  {       
    if(SLA1 != 0 && Bid>= buyprice+SLA1*Point) {newsl=buyprice-SL1*Point;}
    if(SLA2 != 0 && Bid>= buyprice+SLA2*Point) {newsl=buyprice-SL2*Point;}
    if(SLA3 != 0 && Bid>= buyprice+SLA3*Point) {newsl=buyprice-SL2*Point;}
    
    if(newsl>currentsl && newsl != 0)
    {
      for(cnt=0;cnt<OrdersTotal();cnt++)   
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Blue);}   
      } 
    }
  }
  else if(tradedirection()==0)
  {    
    if(SLA1 != 0 && Ask<= buyprice-SLA1*Point) {newsl=buyprice+SL1*Point;}
    if(SLA2 != 0 && Ask<= buyprice-SLA2*Point) {newsl=buyprice+SL2*Point;}
    if(SLA3 != 0 && Ask<= buyprice-SLA3*Point) {newsl=buyprice+SL2*Point;}
    
    if(newsl<currentsl && newsl != 0)
    {
      for(cnt=0;cnt<OrdersTotal();cnt++)   
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Blue);}   
      } 
    }
  }
}


int trades()
{
  int trades=0;
  
  if(TP1>0){trades ++;}
  if(TP2>0){trades ++;}
  if(TP3>0){trades ++;}
  
  return(trades);
}

int opentrades()
{
  int trades=0;
  int cnt;
  
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) {trades ++;}
  }     
  return(trades);
}


int endofday()
{
  int endofday=0; 
  if(Hour()>22) {endofday=1;}
  if(DayOfWeek()==5 && Hour()>18) {endofday=1;}
  return(endofday);
}


void closealltrades()
{
  int cnt;
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	 {		
	 	 if(OrderType() == 1) 	
	 	 {OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Yellow);}
	 	 else {OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Yellow);}
	 }
  }
}

 
int tradedirection()
{

  int cnt;
  int direction=5;
  
  for(cnt=OrdersTotal();cnt>=0;cnt--)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	 {				
	 	 if (OrderType() == 0) {direction=1;}
	 	 if (OrderType() == 1) {direction=0;}
	 	 cnt=-1;
	 }
  }
  return (direction);
}
 


 